### Deploy CP Platform

    usage: ./deployCP -c <component_name> -p <platform_name>

    -c | --component    : required field, any one: all, operator, zookeeper, kafka, schemaregistry,replicator, controlcenter, ksql
    -s | --security     : default to sasl, supports: sasl, sasl_ssl, tls, tls2way
    -p | --platform     : required field, supports: aws,gcp
    -n | --namespace    : default to operator, any kubernetes namespace name
    -a | --helm-args    : override helm arguments with --set command with quotes if required
    -d | --helm-delete  : delete helm release
    -f | --helm-file    : provide custom helm chart's values.yaml file, e.g /tmp/values.yaml
    -t | --debug        : enable debugging
    -u | --upgrade      : Upgrade command
    -r | --retries      : retries for kubernetes resources, default 10 times with exponential backoff.
    -h | --help         : Usage command

### Deploy all CP through test helm chart's file.

#### Pre-requisite

1. Storage Class

        AWS : The test file assumes kubernetes is deployed on region us-west-2 and zones: us-west-2a, us-west-2b, us-west-2c 
        GCP : The test file assumes kuberentes is deployed on region us-central1 and zone: us-central1-a
    
    If your kubenetes deployment is different, change accordingly and use -f option

#### SASL/PLAIN

    ./deployCP.sh -c all -p aws

#### SASL/SSL

    ./deployCP.sh -c all -p aws -s sasl_ssl

#### TLS (1 way)

    ./deployCP.sh -c all -p aws -s tls

#### TLS (2 way)

    ./deployCP.sh -c all -p aws -s tls2way

### Delete

    ./deployCP.sh -c all -p aws -d

### Deploy Custom helm chart's

Custom helm chart file with debug enabled

    ./deployCP.sh -c all -p aws -f <your_values.yaml> --debug

The -p will be ignored when passing -f file.

### Upgrade Components

    ./deployCP.sh -c <component> -p aws -u --debug

### Pass Helm arguments

    ./deployCP.sh -c <component> -p aws -u --debug -a '--set <component>.replicas=1'

### Helm Release Name Changes

    ./deployCP.sh -c <component> -p aws -u --debug -a '--set <component>.name=testdemo'

Only available for a specific component deployment for now. For above command, the name 
of release will be `${USER}-testdemo`, where `${USER}` is the login user.

### Deploy specific component

Make sure to run in sequence

    ./deployCP.sh -c operator -p aws --debug true
    ./deployCP.sh -c zookeeper -p aws --debug true
    ./deployCP.sh -c kafka -p aws --debug true
    ./deployCP.sh -c schemaregistry -p aws --debug true
    ./deployCP.sh -c connect -p aws --debug true
    ./deployCP.sh -c replicator -p aws --debug true
    ./deployCP.sh -c controlcenter -p aws --debug true

### Delete specific component

     ./deployCP.sh -c controlcenter -p aws -d
     ./deployCP.sh -c replicator -p aws -d
     ./deployCP.sh -c connect -p aws -d
     ./deployCP.sh -c schemaregistry -p aws  -d
     ./deployCP.sh -c kafka -p aws  -d
     ./deployCP.sh -c zookeeper -p aws -d
     ./deployCP.sh -c operator -p aws -d
     
     or you can also use `helm delete` command to delete
     
     helm delete --purge `component_name`
